#ifndef COMMON_H
#define COMMON_H

static long value = 0;                      // регулируемое значение
static int multy = 100;                     // петлевое усиление (в %)
#define MAX_LEN 30
#define NPTS 3
static const char *directory = "asu"; 
static const char *points[ NPTS ] = { "value", "increment", "multiply" };

#ifndef __KERNEL__                          // only user space applications
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>

long get_value( void );
void set_value( long );
int  get_multy( void );
void set_multy( int );
void do_step( int step );
#endif

#endif
